#pragma once


template<typename T>
struct Image{
    int width;
    int height;
    T* elements;
    size_t stride_in_bytes;

    __host__ __device__ T GetElement(int row, int col) const
    {
        return *((T*)((char*)elements + row * stride_in_bytes) + col);
    }

    __host__ __device__ void SetElement(int row, int col, T value)
    {
        *((T*)((char*)elements + row * stride_in_bytes) + col) = value;
    }
};

typedef Image<uchar4> ImageRGBA;
typedef Image<float4> ImageF4;